From 7d3c98e87b2d689e4a49252cfb1b6bf8f7fe30cc Mon Sep 17 00:00:00 2001
From: Xavier Lacot <xavier@lacot.org>
Date: Wed, 26 Jun 2013 14:20:50 +0200
Subject: [PATCH] fixed #37 - isChanged() returns true for database-loaded
 records

---
 joli.js | 12 ++++++------
 1 file changed, 6 insertions(+), 6 deletions(-)

diff --git a/joli.js b/joli.js
index 5bd2f6d..12a7652 100644
--- a/joli.js
+++ b/joli.js
@@ -754,6 +754,7 @@ var joliCreator = function() {
             table: table
         };
         this._data = {};
+        this._originalData = null;
     };
 
     joli.record.prototype = {
@@ -765,15 +766,14 @@ var joliCreator = function() {
             }
         },
         fromArray: function(data) {
+            var wasNew = this.isNew ? this.isNew() : true;
+
             if (typeof data.id !== 'undefined') {
-                this._originalData = {
-                    id: data.id
-                };
+                this._originalData = this._originalData || {};
                 this.isNew = function() {
                     return false;
                 };
-            } else {
-                this._originalData = null;
+            } else if (wasNew) {
                 this.isNew = function() {
                     return true;
                 };
@@ -785,7 +785,7 @@ var joliCreator = function() {
                 this._data[colName] = null;
                 this._data[colName] = data[colName];
 
-                if (this._originalData && this.isNew()) {
+                if ((this._originalData && !this._originalData[colName]) || this.isNew()) {
                     this._originalData[colName] = data[colName];
                 }
             }, this);
